Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #1007

Segfault from 6/30 git (Qt interfaces)
July 01, 2020 02:15 - Jim Turner

Status: Closed Start date: July 01, 2020
Priority: Trivial Due date:

Assignee: % Done: 100%
Category: libaudqt Estimated time: 0.00 hour
Target version:

Affects version: 4.0.4

Description

Audacious will segfault on exit if [Settings].[Plugins].{any plugin}.[config options window] left open when exiting Audacious in Qt
interfaces. the corresponding [info options windows] are not subject to this b/c they're modal (can not interact with main window
whilst one of them is open).

Steps to reproduce:

1) Start up Audacious normally (Qt) NOTE: GTK startup does not seem to fail.

2) Open [File].[Settings].[Plugins] window. (window pops up correctly)

3) Select any plugin which has config. options (click wrench/screwdriver icon). (window pops up correctly)

4) Select [File].[Quit] from main window (segfault). NOTE: Pbm. seems to be the fact the options window was left open, as it does
not matter if the (parent) Plugins window itself is still displayed or not.

GTK interfaces don't seem to be affected, but both Qt & Qt-skins are.
I'm marking this as "trivial” b/c it only happens on exit and config/playlist changes seem to STILL be saved, so pbly not noticable to
must users.

History

#1 - July 01, 2020 17:55 - Thomas Lange

Which Qt version are you using?
| was not able to reproduce this issue on Arch Linux with Qt 5.15.

#2 - July 02, 2020 03:57 - Jim Turner

The testing box | was using (that fails) is 32bit, running Qt v5.7.1,
however my main box is 64bit running v5.12.5 but it seems to work properly there.

Idk how "old" or how widely used v5.7.1 still is, so can't say then if this is worth fixin' or not? If it's below your supported Qt version and difficult to fix,
then ok w/me to reject without prejudice.

#3 - July 02, 2020 15:31 - John Lindgren

| see no crash with Qt 5.3.2 either. Is there a particular plugin that this happens with?

#4 - July 04, 2020 05:27 - Jim Turner

| tried at least a half dozen of 'em (most, but not all are "Input” plugins - that have config parms), failed on all | tried. I'm guessing it's a failure to clean
something up that normally gets cleaned up when the subwindow is closed by the user.

#5 - July 04, 2020 06:09 - Jim Turner

The last thing in the backtrace says "0xb7547bb3 in QObject::~QObject() ()", so decided to do a slight bit of digging in prefs-plugin.cc (where these
subwindows are created) and found that:

QObject::connect(cw->root, &QObject::destroyed, [p, cw]() {...

gets called when user presses the [Close] button, and does a cw->root = nullptr; but this is NOT called when exiting Audacious with the window left
open (dangling?) Hope this is the right haystack.

Regards,

Jim

#6 - July 07, 2020 17:56 - John Lindgren

Jim, see if this commit helps:

https://github.com/audacious-media-player/audacious/commit/c253e31802c141864b3afe5b81605889561a97da

#7 - July 07, 2020 23:52 - Jim Turner

That seems to have fixed it! However, | had to #include <memory> in prefs-plugin.cc to get to compile (compiler did not recognize
std::unique_ptr)! (gcc -v=gcc version 6.3.0 20170516 (Debian 6.3.0-18+deb9u1)) on this old 32bit box where it was failing before.

prefs-plugin.cc:
@e -17,6 +17,7 Q@

* the use of this software.

=/
+#include
#include

#include
#include

Thanks,

Jim

#8 - July 08, 2020 16:33 - John Lindgren

<memory>

<QDhialog>
<QDialogButtonBox>
<QPointer>

- % Done changed from 0 to 100

- Status changed from New to Closed

Okay, that should be fixed now too. Thanks for testing!
